SpinnyBird.PlayBlitzScreen = function (game) {
};

SpinnyBird.PlayBlitzScreen.prototype = {

    preload: function () {

      this.score = SpinnyBird.defaults.score;
      this.timer = SpinnyBird.defaults.timer;
      this.spinnyScore = this.add.retroFont('spinny-font',12,12,Phaser.RetroFont.TEXT_SET10+'!?"\'#$%&()[]*+-.:;=<>@^`~/0123456789');
      this.spinnyScore.text = leftpad(this.timer, 2) + ' / ' + leftpad(this.score, 2);

      this.spinnyPausedText = this.add.retroFont('spinny-font',12,12,Phaser.RetroFont.TEXT_SET10);
      this.spinnyPausedText.text = 'PAUSED';

      this.spinnyGiveUpText = this.add.retroFont('spinny-font',12,12,Phaser.RetroFont.TEXT_SET10);
      this.spinnyGiveUpText.text = 'GIVE UP';

      this.spinnyContinueText = this.add.retroFont('spinny-font',12,12,Phaser.RetroFont.TEXT_SET10);
      this.spinnyContinueText.text = 'CONTINUE';

      this.spinnyPromptContinueText = this.add.retroFont('spinny-font',12,12,Phaser.RetroFont.TEXT_SET10+'!?');
      this.spinnyPromptContinueText.text = 'CONTINUE?';

      this.spinnyPromptGiveUpText = this.add.retroFont('spinny-font',12,12,Phaser.RetroFont.TEXT_SET10);
      this.spinnyPromptGiveUpText.text = 'GIVE UP';

      this.spinnyPromptWatchAdText = this.add.retroFont('spinny-font',12,12,Phaser.RetroFont.TEXT_SET10);
      this.spinnyPromptWatchAdText.text = 'WATCH AD';

    },

    create: function () {

    	// set up defaults
    	SpinnyBird.setScore(0);

    	/* gameplay variables */
    	this.birdAngle = SpinnyBird.defaults.angle;
    	this.birdVelocity = SpinnyBird.defaults.velocity;
    	this.birdAngularVelocity = SpinnyBird.defaults.angularVelocity;
    	this.spacesCount = SpinnyBird.defaults.spacesCount;
      this.bouncing_LR = false;
      this.bouncing_TB = false;
    	this.go_bird = false;
    	this.spaces = new Uint8Array(this.spacesCount);
      this.canContinue = true;

      this.stopwatch = this.time.create(false);
      this.stopwatch.loop(1000, this.updateTimer, this);
      this.stopwatch.start();

    	var graphics = this.add.graphics(85, 87);
    	graphics.lineStyle(2, 0xFFFFFF)
    	graphics.drawRect(2, 0, 306, 2, 1);
      graphics.drawRect(0, 2, 2, 308, 1);
      graphics.drawRect(2, 310, 306, 2, 1);
      graphics.drawRect(308, 2, 2, 308, 1);
      graphics.lineStyle(2, 0x9badb7);
      graphics.drawRect(4, 4, 302, 2, 1);
      graphics.drawRect(0, 312, 2, 2, 1);
      graphics.drawRect(2, 314, 306, 2, 1);
      graphics.drawRect(308, 312, 2, 2, 1);

    	this.walls_tb = this.add.physicsGroup(Phaser.Physics.ARCADE);
  		this.walls_lr = this.add.physicsGroup(Phaser.Physics.ARCADE);

  		var wall_top = this.walls_tb.create(83, 85, 'wall');
  		wall_top.scale.setTo(314, 5);
  		wall_top.body.immovable = true;

  		var wall_right = this.walls_lr.create(392, 90, 'wall');
  		wall_right.scale.setTo(5, 306);
  		wall_right.body.immovable = true;

  		var wall_bottom = this.walls_tb.create(83, 396, 'wall');
  		wall_bottom.scale.setTo(314, 5);
  		wall_bottom.body.immovable = true;

  		var wall_left = this.walls_lr.create(83, 90, 'wall');
  		wall_left.scale.setTo(5, 306);
  		wall_left.body.immovable = true;

  		this.coins = this.add.physicsGroup(Phaser.Physics.ARCADE);

  		this.bird = this.add.sprite(240, 240, 'hero-'+SpinnyBird.getHero());
      this.bird.animations.add('bye', [0,1,2,3,4,5,6,7], 12.5);
      this.bird.animations.add('hover', [0], 12.5);
      this.bird.animations.add('fly', Phaser.ArrayUtils.numberArray(8, this.bird.animations.frameTotal-1), 12.5, true);
  		this.bird.anchor.set(0.5, 0.5);
  		this.bird.angle = this.birdAngle;
  		this.bird.alpha = 0;
  		this.bird.playable = true;
      this.bird.bouncing_TB = false;
      this.bird.bouncing_LR = false;
  		this.add.tween(this.bird).to({alpha:1}, 200, Phaser.Easing.Quadratic.In, true);
  		this.physics.arcade.enable(this.bird);
      this.bird.body.setSize(26, 26, Math.floor((SpinnyBird.getHeroWidth()-26)/2), 14);
  		this.bird.body.allowGravity = false;
  		this.bird.body.collideWorldBounds = true;
  		this.bird.body.bounce.setTo(1, 1);
  		this.bird.body.angularVelocity = this.birdAngularVelocity;

      this.bird.animations.play('hover');

		  this.createACoin(true);

      this.scoreText = this.add.image(90, 50, this.spinnyScore);
      this.scoreText.scale.setTo(2,2);
      this.scoreText.anchor.setTo(0,0.5);

      Mousetrap.reset();

      Mousetrap.bind(['p', 'esc'], () => { this.btnPauseHandler(); }, 'keyup');

		  this.btnPause = this.add.button(393, 50, 'sprite-pause', this.btnPauseHandler, this, 0, 0, 1);
      this.btnPause.anchor.setTo(1, 0.5);

  		this.imgGo = this.add.sprite(240, 436, 'sprite-play');
  		this.imgGo.anchor.setTo(0.5, 0.5);
      this.imgGo.inputEnabled = true;
      this.imgGo.input.useHandCursor = true;

  		this.btnGo = this.add.sprite(80, 85, 'wall');
  		this.btnGo.scale.setTo(320, 395);
  		this.btnGo.inputEnabled = true;
  		this.btnGo.input.useHandCursor = true;
  		this.btnGo.events.onInputDown.add(this.goBird, this);
  		this.btnGo.events.onInputUp.add(this.stopBird, this);

      Mousetrap.bind(['space', 'enter'], () => { this.goBird(); }, 'keydown');
      Mousetrap.bind(['space', 'enter'], () => { this.stopBird(); }, 'keyup');

    },

    updateTimer: function() {
      if(this.timer > 0) {
        this.timer = this.timer - 1;
        this.spinnyScore.text = leftpad(this.timer, 2) + ' / ' + leftpad(this.score, 2);
      }
      if(this.timer < 1) {
        SpinnyBird.playSound('hit_bomb');
        this.bird.playable = false;
        this.bird.animations.play('bye');
        SpinnyBird.setScore(this.score);
        this.bird.events.onAnimationComplete.add(function() {

          this.state.start('GameOverScreen');

        }, this);
      }
    },

    goBird: function() {
      if(this.go_bird!=true) {
        this.go_bird = true;
        this.imgGo.frame = 1;
        if(this.bird.playable) {
          this.bird.animations.play('fly');
        }
      }
    },

    stopBird: function() {
      this.go_bird = false;
      this.imgGo.frame = 0;
      if(this.bird.playable) {
        this.bird.animations.play('hover');
      }
    },

    btnPauseHandler: function() {
      SpinnyBird.playSound('click');
    	this.game.paused = true;
    	this.btnPause.alpha = 0;
      this.imgGo.alpha = 0;

    	this.pauseMenu = this.add.group();
    	var backdrop = this.pauseMenu.create(110, 200, 'pause-menu-bg');

      var pausedText = this.add.image(393, 50, this.spinnyPausedText, {}, this.pauseMenu);
    	pausedText.anchor.setTo(1, 0.5);
      pausedText.scale.setTo(2,2);

    	var giveUpText = this.add.text(240, 230, 'Give up', {font:'16px PixelBerry', fill:'#000'}, this.pauseMenu);
    	giveUpText.anchor.setTo(0.5, 0.5);

      Mousetrap.bind('q', () => { this.unpauseHandler({x:31,y:199}); }, 'keyup');

    	var continueText = this.add.text(240, 280, 'Continue', {font:'16px PixelBerry', fill:'#000'}, this.pauseMenu);
    	continueText.anchor.setTo(0.5, 0.5);

      Mousetrap.bind(['p', 'esc'], () => { this.unpauseHandler({x:31,y:251}); }, 'keyup');

    	this.input.onDown.add(this.unpauseHandler, this);
   	},

   	unpauseHandler: function(event) {

      Mousetrap.unbind(['p','esc','q'], 'keyup');

      Mousetrap.bind(['p', 'esc'], () => { this.btnPauseHandler(); }, 'keyup');

      if(this.game.paused) {
   			if(event.x > 110 && event.x < 370 && event.y > 198 && event.y < 245) {
          SpinnyBird.playSound('hit_bomb');
          this.input.onDown.remove(this.unpauseHandler, this);
          this.pauseMenu.destroy();
          this.game.paused = false;
          this.btnPause.alpha = 1;
          this.imgGo.alpha = 1;
          this.bird.playable = false;
          this.bird.animations.play('bye');
          SpinnyBird.setScore(this.score);
          this.bird.events.onAnimationComplete.add(function() {

            this.state.start('GameOverScreen');

          }, this);
   			} else if(event.x > 110 && event.x < 370 && event.y > 250 && event.y < 298) {
          SpinnyBird.playSound('click');
          this.input.onDown.remove(this.unpauseHandler, this);
          this.pauseMenu.destroy();
          this.game.paused = false;
          this.btnPause.alpha = 1;
          this.imgGo.alpha = 1;
   			}
   		}
   	},

    update: function() {

    	this.physics.arcade.overlap(this.bird, this.walls_tb, this.birdBounceTB, null, this);
  		this.physics.arcade.overlap(this.bird, this.walls_lr, this.birdBounceLR, null, this);
  		this.physics.arcade.overlap(this.bird, this.coins, this.collectCoin, null, this);

  		if(this.go_bird && this.bird.playable) {
  			this.bird.body.angularVelocity = 0;
  			this.bird.body.velocity.copyFrom(this.physics.arcade.velocityFromAngle(this.bird.angle, this.birdVelocity));
  		}
  		else {
  			this.bird.body.angularVelocity = this.birdAngularVelocity;
    		this.bird.body.velocity.set(0, 0);
  		}

    },

    render: function() {
/*
      game.debug.body(this.bird);

      this.coins.forEachAlive(function(member) {
        game.debug.body(member);
      }, this);

      this.walls_tb.forEachAlive(function(m) {
        game.debug.body(m);
      }, this);
      this.walls_lr.forEachAlive(function(m) {
        game.debug.body(m);
      }, this);
*/
    },

    birdBounceTB: function(bird, wall) {
    	if(!bird.playable || bird.bouncing_TB) { return; }
      bird.playable = false;
      bird.bouncing_TB = true;
      bird.body.velocity.set(0, 0);
    	bird.angle = 0 - bird.angle;
    	if(bird.y > wall.y) {
    		bird.y += 2;
    	}
    	else {
    		bird.y -= 2;
    	}
    	bird.body.velocity.copyFrom(this.physics.arcade.velocityFromAngle(bird.angle, this.birdVelocity));
      bird.bouncing_TB = false;
      bird.playable = true;
    },

    birdBounceLR: function(bird, wall) {
    	if(!bird.playable || bird.bouncing_LR) { return; }
      bird.playable = false;
      bird.bouncing_LR = true;
      bird.body.velocity.set(0, 0);
		  bird.angle = 180 - bird.angle;
		  if( bird.x > wall.x ) {
		    bird.x += 2;
		  }
		  else {
		    bird.x -= 2;
		  }
		  bird.body.velocity.copyFrom(this.physics.arcade.velocityFromAngle(bird.angle, this.birdVelocity));
      bird.bouncing_LR = false;
      bird.playable = true;
    },

    collectCoin: function(bird, coin) {
    	if(!bird.playable) { return; }

      var collectedCoin = function() {
        coin.kill();
      };

      SpinnyBird.playSound('collect_coin');
      this.score += coin.coin_value;
      this.spinnyScore.text = leftpad(this.timer, 2) + ' / ' + leftpad(this.score, 2);
      this.coins.remove(coin);
      this.world.add(coin);
      coin.animations.play('bye');
      coin.events.onAnimationComplete.add(collectedCoin, this);

      this.spaces = new Uint8Array(this.spacesCount);
      this.createACoin();
      this.birdVelocity += 5;
      this.birdAngularVelocity += 5;
    },

    promptContinue: function() {

      this.game.paused = true;
      this.canContinue = false;
      this.btnPause.alpha = 0;
      this.imgGo.alpha = 0;

      this.promptMenu = this.add.group();
      var backdrop = this.promptMenu.create(110, 200, 'pause-menu-bg');

      var promptText = this.add.image(393, 50, this.spinnyPromptContinueText, {}, this.promptMenu);
      promptText.anchor.setTo(1, 0.5);
      promptText.scale.setTo(2, 2);

      var giveUpText = this.add.text(240, 230, 'Give up', {font:'16px PixelBerry', fill:'#000'}, this.promptMenu);
      giveUpText.anchor.setTo(0.5, 0.5);

      Mousetrap.unbind(['p', 'esc', 'q'], 'keyup');
      Mousetrap.bind('q', () => { this.promptContinueHandler({x:31,y:199}); }, 'keyup');

      var oneMoreTry = this.add.text(240, 280, 'One more try', {font:'16px PixelBerry', fill:'#000'}, this.promptMenu);
      oneMoreTry.anchor.setTo(0.5, 0.5);

      Mousetrap.unbind(['space', 'enter'], 'keydown');
      Mousetrap.unbind(['space', 'enter'], 'keyup');
      Mousetrap.bind(['space', 'enter'], () => { this.promptContinueHandler({x:31,y:251}); }, 'keyup');

      this.input.onDown.add(this.promptContinueHandler, this);

    },

    promptContinueHandler: function(event) {
      if(this.game.paused) {
        if(event.x > 110 && event.x < 370 && event.y > 198 && event.y < 245) {

          SpinnyBird.playSound('click');
          this.input.onDown.remove(this.promptContinueHandler, this);
          this.promptMenu.destroy();
          this.game.paused = false;
          this.btnPause.alpha = 1;
          this.imgGo.alpha = 1;
          this.bird.playable = false;
          SpinnyBird.setScore(this.score);
          this.state.start('GameOverScreen');

        } else if(event.x > 110 && event.x < 370 && event.y > 250 && event.y < 298) {

          SpinnyBird.playSound('click');
          this.game.paused = false;
          this.btnPause.alpha = 1;
          this.imgGo.alpha = 1;
          this.bird.events.destroy();
          this.bird.playable = true;
          this.bird.animations.play('hover');
          this.promptMenu.destroy();

          Mousetrap.unbind(['space', 'enter', 'q'], 'keyup');
          Mousetrap.bind(['p', 'esc'], () => { this.btnPauseHandler(); }, 'keyup');
          Mousetrap.bind(['space', 'enter'], () => { this.goBird(); }, 'keydown');
          Mousetrap.bind(['space', 'enter'], () => { this.stopBird(); }, 'keyup');

        }
      }
    },

    getAvailableSpace: function() {
    	var bird_index = parseInt( (this.bird.x - 106.5) / 25 ) + (11 * parseInt( (this.bird.y - 102.5) / 25 ));
    	var bird_indexes = [
		    bird_index - 12,
		    bird_index - 11,
		    bird_index - 10,
		    bird_index - 9,
		    bird_index - 1,
		    bird_index,
		    bird_index + 1,
		    bird_index + 2,
		    bird_index + 9,
		    bird_index + 10,
		    bird_index + 11,
		    bird_index + 12
		  ];

		  var available_spaces = [];
		  for(var i=0; i<this.spaces.length; i++) {
		  	if(this.spaces[i] == 0 && bird_indexes.indexOf(i) < 0) {
		      available_spaces.push(i);
		    }
		  }
		  if(available_spaces.length < 1) { return false; }
		  var rand_index = available_spaces[ Math.floor( Math.random() * available_spaces.length ) ];
		  var y_index = parseInt(rand_index / 11);
		  var x_index = parseInt(rand_index % 11);
		  var x = x_index * 25 + 120;
		  var y = y_index * 25 + 120;
		  return {index:rand_index,x:x,y:y};
    },

    createACoin: function(first) {
    	var available_location = this.getAvailableSpace();
		  if(available_location === false) { return; }
		  this.spaces[ available_location.index ] = 1; // for a coin
      var opportunity = Math.min(this.score * 3, 49);
      var selection = Math.floor(Math.random() * opportunity);
      var value = 1;
      if(selection >= 45) { selection = 'sprite-banana'; value = 5; }
      else if(selection >= 35) { selection = 'sprite-pear'; value = 3; }
      else if(selection >= 20) { selection = 'sprite-orange'; value = 2; }
      else { selection = 'sprite-apple'; value = 1; }
		  var a_coin = this.add.sprite( available_location.x, available_location.y, selection);
      a_coin.animations.add('bye',[0,1,2,3,4,5,6,7,8], 12.5);
	    a_coin.anchor.setTo(0.5, 0.5);
	    a_coin.alpha = 0.1;
      a_coin.coin_value = value;
	    this.add.tween(a_coin).to({alpha: 1}, 200, Phaser.Easing.Quadratic.In, true);
      if(first) {
        this.add.tween(a_coin.scale).to({x:1.5,y:1.5}, 800, Phaser.Easing.Linear.None, true, 0, -1, true); //.to({x:1,y:1}, 1000, Phaser.Easing.Quadratic.Out, true).loop(true);
      }
	    this.coins.add(a_coin);
      a_coin.body.setSize(15, 16, 20, 19);
      a_coin.body.allowGravity = false;
    },

};